﻿Module ModuleScope

    Public Class Channel
        Public Slot As Int32
        Public neg As Boolean
        Public Max As Single
        Public Min As Single
        Public ValueMax As Single
        Public ValueMin As Single
        Public Value_Normalized As Single
        Public Value_Zero As Single
        Public Value As Single
        Public vDiv As Single
        Public RemoveDC As Boolean
        Sub New()
            Slot = -1
            Max = 1000
            Min = 0
        End Sub
    End Class

    Friend ch1 As Channel = New Channel
    Friend ch2 As Channel = New Channel

    Friend CursorsEnabled As Boolean
    Friend Cursor1 As Single = 0.33
    Friend Cursor2 As Single = 0.66
    Friend ScopeRun As Boolean
    Friend TriggerCh As Int32

    ' ------------------------------------     30'000 =                 60 sec * 500 sps (60 kilo bytes)
    ' ------------------------------------  1'800'000 =  1 h * 60 min * 60 sec * 500 sps ( 2 mega bytes)
    ' ------------------------------------  3'600'000 =  2 h * 60 min * 60 sec * 500 sps ( 4 mega bytes)
    ' ------------------------------------ 10'800'000 =  6 h * 60 min * 60 sec * 500 sps (22 mega bytes)
    ' ------------------------------------ 21'600'000 = 12 h * 60 min * 60 sec * 500 sps (43 mega bytes)
    ' ------------------------------------ 43'200'000 = 24 h * 60 min * 60 sec * 500 sps (86 mega bytes)

    Const FifoLen As Int32 = 43200000        '  1800000  43200000
    Friend fifo1 As FIFO = New FIFO(FifoLen)

    Private m_pbox As PictureBox

    Private m_SampleFreq As Int32 = 500
    Private m_SampleMillisec As Int32 = 2

    Private m_msDiv As Single = 100
    Private m_DeltaTime As Single

    Private hpix As Int32
    Private wpix As Int32

    Private vpp As Single

    Private g As Graphics

    Private BackColor As Color = Color.FromArgb(250, 242, 242)
    Private ScalePen1 As Pen = New Pen(Color.FromArgb(140, 140, 140))
    Private ScalePen2 As Pen = New Pen(Color.FromArgb(160, 160, 160))
    Private tracePen1 As Pen = New Pen(Color.DarkBlue, 2)
    Private tracePen2 As Pen = New Pen(Color.DarkRed, 2)
    Private cursorPen As Pen = New Pen(Color.FromArgb(0, 120, 0), 3)
    Private cursorBrush As Brush = New SolidBrush(Color.FromArgb(0, 60, 0))
    Private textFont As Font = New Font("Arial", 9, FontStyle.Bold)
    Private TextBrush As Brush = New SolidBrush(Color.FromArgb(30, 0, 0))
    Private TextBrush1 As Brush = New SolidBrush(Color.DarkBlue)
    Private TextBrush2 As Brush = New SolidBrush(Color.DarkRed)
    Private BackBrush As Brush = New SolidBrush(Color.FromArgb(150, 250, 250, 180))
    Private HiLightBrush As Brush = New SolidBrush(Color.FromArgb(180, 250, 250, 0))
    Private BackBrush2 As Brush = New SolidBrush(Color.FromArgb(250, 250, 180))

    Friend Sub InitGraphics(ByVal pbox As PictureBox, Optional ByVal HiQuality As Boolean = True)
        m_pbox = pbox
        InitPictureboxImage(m_pbox)
        g = Graphics.FromImage(m_pbox.Image)
        If HiQuality Then
            g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
            tracePen1.Width = 2
            tracePen2.Width = 2
        Else
            g.SmoothingMode = Drawing2D.SmoothingMode.HighSpeed
            tracePen1.Width = 1
            tracePen2.Width = 1
        End If
        hpix = m_pbox.Image.Height - 1
        wpix = m_pbox.Image.Width - 2
        cursorPen.DashStyle = Drawing2D.DashStyle.Dot
    End Sub

    Friend Sub SetBaseTime(ByVal basetime As String)
        m_msDiv = CSng(Val(basetime))
        If basetime.Contains("mS") Then
            '
        ElseIf basetime.Contains("Sec") Then
            m_msDiv *= 1000
        ElseIf basetime.Contains("Min") Then
            m_msDiv *= 60000
        End If
        LimitDeltaTime()
    End Sub

    Friend Sub UpdateDeltaTimeBy(ByVal DeltaPixels As Int32)
        m_DeltaTime += DeltaPixels * m_msDiv / wpix * 20
        LimitDeltaTime()
    End Sub

    Friend Sub SetDeltaTime(ByVal newDeltaTime As Single)
        m_DeltaTime = newDeltaTime
        LimitDeltaTime()
    End Sub

    Friend Sub ResetDeltaTime()
        m_DeltaTime = 0
    End Sub

    Friend Function GetDeltaTime() As Single
        Return m_DeltaTime
    End Function

    Private Sub LimitDeltaTime()
        If m_DeltaTime < 0 Then m_DeltaTime = 0
        Dim MaxDelta As Single = FifoLen * 2 - m_msDiv * 20
        If m_DeltaTime > MaxDelta Then m_DeltaTime = MaxDelta
    End Sub


    ' ================================================================================
    '  Aquisition with the AccurateTimer
    ' ================================================================================
    Private WithEvents m_Timer As AccurateTimer = New AccurateTimer
    Private v1, v2, oldv1, oldv2 As Single
    Private z1, z2 As Single

    Private Sub m_Timer_TimerTick(ByVal TotalMillisec As Double) Handles m_Timer.TimerTick
        v1 = Slots.ReadSlot_NoNan(ch1.Slot)
        v2 = Slots.ReadSlot_NoNan(ch2.Slot)
        ' -------------------------------------------------- DC remover
        If ch1.RemoveDC Then
            v1 -= z1
            z1 += v1 / 100.0F
        End If
        If ch2.RemoveDC Then
            v2 -= z2
            z2 += v2 / 100.0F
        End If
        ' -------------------------------------------------- Stop tester
        fifo1.AddElement(New FIFO.FifoEntry(v1, v2))
        Select Case StopMethod
            Case 1
                If TripStatus = 0 Then
                    If v1 >= StopTripPoint And oldv1 < StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v1 < StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
            Case 2
                If TripStatus = 0 Then
                    If v1 <= StopTripPoint And oldv1 > StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v1 > StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
            Case 3
                If TripStatus = 0 Then
                    If v2 >= StopTripPoint And oldv2 < StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v2 < StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
            Case 4
                If TripStatus = 0 Then
                    If v2 <= StopTripPoint And oldv2 > StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v2 > StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
        End Select
        oldv1 = v1
        oldv2 = v2
    End Sub
    Friend Sub StartStopAcquisition(ByVal run As Boolean)
        If run Then
            m_Timer.SetInterval(m_SampleMillisec)
            m_Timer.StartTimer()
            fifo1.Flush()
        Else
            m_Timer.StopTimer()
        End If
        ' ------------------------------------- reset stop vars
        StopEventCounter = 0
        StopFlag = False
    End Sub

    ' ================================================================================
    '  Stop by events
    ' ================================================================================
    Friend StopMethod As Int32 = 0
    Friend StopTripPoint As Single = 0
    Friend StopNumEvents As Int32 = 0
    Friend StopFlag As Boolean
    Private StopEventCounter As Int32 = 0
    Private TripStatus As Int32 = 0
    'Private Sub TestStop(ByVal n As Single, 


    ' ================================================================================
    '  SCOPE UPDATE
    ' ================================================================================
    Friend Sub ScopeUpdate()

        If m_pbox Is Nothing Then Return
        If m_pbox.Image Is Nothing Then Return

        Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
        ' ------------------------------------------------------------------ 
        Dim i, ix As Int32
        Dim x As Single
        Dim oldx As Int32
        Dim oldy1 As Single
        Dim oldy2 As Single
        Dim h1, h2 As Single
        Dim preTrigSamples As Int32
        Dim FifoReadIndex As Int32
        Dim v1, v2 As Single
        Dim v1min, v2min As Single
        Dim v1max, v2max As Single
        Dim y, y1, y2 As Single
        Dim kmv1 As Single = hpix / 10.0F / ch1.vDiv
        Dim kmv2 As Single = hpix / 10.0F / ch2.vDiv
        Dim kw As Single = m_SampleFreq / 50.0F * m_msDiv / wpix
        Dim kw2 As Single = m_msDiv * 20 / wpix
        Dim cursor1x As Int32 = CInt(Cursor1 * wpix)
        Dim cursor2x As Int32 = CInt(Cursor2 * wpix)
        If cursor1x > cursor2x Then
            Dim d As Int32 = cursor1x
            cursor1x = cursor2x
            cursor2x = d
        End If
        ' ------------------------------------------------------------------ clear
        g.Clear(BackColor)
        ' ------------------------------------------------------------------ draw scale
        For i = 0 To 20
            x = wpix * i \ 20
            Select Case i
                Case 0, 10, 20
                    g.DrawLine(ScalePen2, x - 1, 0, x - 1, hpix)
                    g.DrawLine(ScalePen1, x, 0, x, hpix)
                    g.DrawLine(ScalePen2, x + 1, 0, x + 1, hpix)
                Case Else
                    g.DrawLine(ScalePen1, x, 0, x, hpix)
            End Select
        Next
        For i = 0 To 10
            y = hpix * i \ 10
            Select Case i
                Case 0, 5, 10
                    g.DrawLine(ScalePen2, 0, y - 1, wpix, y - 1)
                    g.DrawLine(ScalePen1, 0, y, wpix, y)
                    g.DrawLine(ScalePen2, 0, y + 1, wpix, y + 1)
                Case Else
                    g.DrawLine(ScalePen1, 0, y, wpix, y)
            End Select
        Next
        ' ------------------------------------------------------------------ Adaptive-trigger or No-trigger
        If TriggerCh <> 0 Then
            ' -------------------------------------------------------------- prepare the FIFO read position
            preTrigSamples = Math.Min(5 * CInt(kw * wpix - 1), FifoLen \ 2)
            FifoReadIndex = CInt(fifo1.GetWriteIndex - preTrigSamples)
            Dim trigpos As Int32 = FifoReadIndex
            Static TrigMin As Single
            Static TrigMax As Single
            Dim min As Single = Single.MaxValue
            Dim max As Single = Single.MinValue
            Dim TrigState As Int32 = 0
            For ix = preTrigSamples To 0 Step -1
                If TriggerCh = 1 Then
                    v1 = fifo1.GetElement(FifoReadIndex + ix).Value1
                    If ch1.neg Then v1 = -v1
                Else
                    v1 = fifo1.GetElement(FifoReadIndex + ix).Value2
                    If ch2.neg Then v1 = -v1
                End If
                If TrigState = 0 AndAlso v1 > TrigMax Then TrigState = 1
                If TrigState = 1 AndAlso v1 < TrigMin Then TrigState = 2
                If TrigState = 2 AndAlso v1 > TrigMax / 10 Then
                    TrigState = -1
                    trigpos = ix - CInt(kw * wpix - 1)
                    Exit For
                End If
                If v1 > max Then max = v1
                If v1 < min Then min = v1
            Next
            Dim margin As Single = (max - min) * 0.1F
            TrigMax = max - margin
            TrigMin = min + margin
            If TrigState = -1 Then
                FifoReadIndex += trigpos
            Else
                FifoReadIndex = CInt(fifo1.GetWriteIndex - kw * wpix) - 1
            End If
        Else
            FifoReadIndex = CInt(fifo1.GetWriteIndex - kw * wpix) - 1
        End If
        ' ------------------------------------------------------------------ delta time 
        FifoReadIndex -= CInt(m_DeltaTime / 2)
        ' ------------------------------------------------------------------ value Zero
        h1 = hpix / 2.0F + kmv1 * ch1.Value_Zero
        h2 = hpix / 2.0F + kmv2 * ch2.Value_Zero
        ' ------------------------------------------------------------------ unused traces
        If ch1.Slot < 0 Then kmv1 = 0 : h1 = -10000
        If ch2.Slot < 0 Then kmv2 = 0 : h2 = -10000
        ' ------------------------------------------------------------------ wave
        oldx = -1
        oldy1 = 0
        oldy2 = 0
        v1min = Single.MaxValue
        v2min = Single.MaxValue
        v1max = Single.MinValue
        v2max = Single.MinValue
        Dim fe As FIFO.FifoEntry
        Dim FifoIndex As Int32
        Dim oldFifoIndex As Int32
        Dim curs1v1, curs1v2 As Single
        Dim curs2v1, curs2v2 As Single
        For ix = 0 To wpix - 1
            FifoIndex = CInt(ix * kw)
            ' ------------------------------------------------------ only if there is a new sample or a cursor
            If FifoIndex = oldFifoIndex Then
                If Not CursorsEnabled AndAlso ix <> cursor1x AndAlso ix = cursor2x Then
                    Continue For
                End If
            End If
            oldFifoIndex = FifoIndex
            ' ------------------------------------------------------ 
            fe = fifo1.GetElement(FifoReadIndex + FifoIndex)
            v1 = fe.Value1
            If ch1.neg Then v1 = -v1
            y1 = h1 - kmv1 * v1
            v2 = fe.Value2
            If ch2.neg Then v2 = -v2
            y2 = h2 - kmv2 * v2
            If v1 > v1max Then v1max = v1
            If v1 < v1min Then v1min = v1
            If v2 > v2max Then v2max = v2
            If v2 < v2min Then v2min = v2
            If oldx >= 0 Then
                If Math.Abs(y1) < 100000 Then g.DrawLine(tracePen1, oldx, oldy1, ix, y1)
                If Math.Abs(y2) < 100000 Then g.DrawLine(tracePen2, oldx, oldy2, ix, y2)
            End If
            oldy1 = y1
            oldy2 = y2
            oldx = ix
            ' ------------------------------------------------------------------ cursors
            If CursorsEnabled Then 'And oldx >= 0 Then
                If ix = cursor1x Then
                    g.DrawLine(cursorPen, ix, 0, ix, hpix)
                    g.DrawEllipse(tracePen1, ix - 4, y1 - 4, 8, 8)
                    PrintXY_Left(v1.ToString(GCI), TextBrush1, BackBrush2, ix - 8, y1 - 6)
                    g.DrawEllipse(tracePen2, ix - 4, y2 - 4, 8, 8)
                    PrintXY_Left(v2.ToString(GCI), TextBrush2, BackBrush2, ix - 8, y2 - 6)
                    curs1v1 = v1
                    curs1v2 = v2
                End If
                If ix = cursor2x Then
                    g.DrawLine(cursorPen, ix, 0, ix, hpix)
                    g.DrawEllipse(tracePen1, ix - 4, y1 - 4, 8, 8)
                    PrintXY_Left(v1.ToString(GCI), TextBrush1, BackBrush2, ix - 8, y1 - 6)
                    g.DrawEllipse(tracePen2, ix - 4, y2 - 4, 8, 8)
                    PrintXY_Left(v2.ToString(GCI), TextBrush2, BackBrush2, ix - 8, y2 - 6)
                    curs2v1 = v1
                    curs2v2 = v2
                End If
            End If
        Next
        '
        If CursorsEnabled Then
            PrintXY("Difference = " + Math.Abs(curs2v1 - curs1v1).ToString(GCI), TextBrush1, BackBrush, 3, 3)
            PrintXY("Difference = " + Math.Abs(curs2v2 - curs1v2).ToString(GCI), TextBrush2, BackBrush, 3, 20)
            Dim ms As Single = (cursor2x - cursor1x) * kw2
            PrintXY_Left("Time difference (ms) = " + ms.ToString(GCI), cursorBrush, BackBrush, wpix - 2, 3)
            PrintXY_Left("Frequency (Hz) = " + (1000 / ms).ToString(GCI), cursorBrush, BackBrush, wpix - 2, 20)
        End If
        '
        If Math.Abs(oldy1) < 100000 Then g.DrawEllipse(tracePen1, oldx - 4, oldy1 - 4, 8, 8)
        If Math.Abs(oldy2) < 100000 Then g.DrawEllipse(tracePen2, oldx - 4, oldy2 - 4, 8, 8)
        '
        Dim hTextLow As Int32 = hpix - 18
        ' ------------------------------------------------------------------ scale text - Vertical/div
        PrintBottom((ch1.vDiv).ToString(GCI) & " / div", TextBrush1, BackBrush, 5)
        PrintBottom((ch2.vDiv).ToString(GCI) & " / div", TextBrush2, BackBrush, 80)
        ' ------------------------------------------------------------------ scale text - TimeBase/div
        If m_msDiv >= 1000 Then
            PrintBottom((m_msDiv / 1000).ToString(GCI) & " Sec / div", TextBrush, BackBrush, wpix - 80)
        Else
            PrintBottom(m_msDiv.ToString(GCI) & " mS / div", TextBrush, BackBrush, wpix - 80)
        End If
        ' ------------------------------------------------------------------ scale text - TimeBase Delta
        If m_DeltaTime > 0 Then
            If m_DeltaTime >= 60000 Then
                PrintBottom("Delta time = " + (m_DeltaTime / 60000).ToString("0.000", GCI) + " min", _
                            TextBrush, HiLightBrush, wpix - 240)
            ElseIf m_DeltaTime >= 1000 Then
                PrintBottom("Delta time = " + (m_DeltaTime / 1000).ToString("0.000", GCI) + " Sec", _
                            TextBrush, HiLightBrush, wpix - 240)
            Else
                PrintBottom("Delta time = " + m_DeltaTime.ToString("0", GCI) + " mS", _
                            TextBrush, HiLightBrush, wpix - 230)
            End If
        End If
        ' ------------------------------------------------------------------ Value Min and Max
        ch1.Value = v1
        ch2.Value = v2
        ch1.ValueMax = v1max
        ch1.ValueMin = v1min
        ch2.ValueMax = v2max
        ch2.ValueMin = v2min
        ' ------------------------------------------------------------------ debug time
        If My.Computer.Keyboard.AltKeyDown Then
            PrintTop("Scope time: " & (sw1.Elapsed.TotalMilliseconds).ToString("0.0") & " mS", _
                     TextBrush, Brushes.Yellow, 8)
        End If
        ' ------------------------------------------------------------------ show
        m_pbox.Invalidate()
    End Sub

    Private Sub PrintXY(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single, ByVal y As Single)
        Dim sz As SizeF = g.MeasureString(str, textFont)
        g.FillRectangle(br2, x, y, sz.Width, sz.Height)
        g.DrawString(str, textFont, br1, x, y)
    End Sub

    Private Sub PrintXY_Left(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single, ByVal y As Single)
        Dim sz As SizeF = g.MeasureString(Str, textFont)
        x -= sz.Width
        g.FillRectangle(br2, x, y, sz.Width, sz.Height)
        g.DrawString(Str, textFont, br1, x, y)
    End Sub

    Private Sub PrintTop(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single)
        Dim sz As SizeF = g.MeasureString(str, textFont)
        x -= sz.Width + 8
        g.FillRectangle(br2, x, 5, sz.Width, sz.Height)
        g.DrawString(str, textFont, br1, x, 5)
    End Sub

    Private Sub PrintBottom(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single)
        Dim sz As SizeF = g.MeasureString(str, textFont)
        g.FillRectangle(br2, x, hpix - 18, sz.Width, sz.Height)
        g.DrawString(str, textFont, br1, x, hpix - 18)
    End Sub

End Module

